var canvasBg = document.getElementById('canvasBg');
var ctxBg = canvasBg.getContext('2d');



var canvasFox = document.getElementById('canvasFox');
var ctxFox = canvasFox.getContext('2d');


var canvasBunny = document.getElementById('canvasBunny');
var ctxBunny = canvasBunny.getContext('2d');





var canvasHUD = document.getElementById('canvasHUD');
var ctxHUD = canvasHUD.getContext('2d');
ctxHUD.fillStyle = "hsla(0, 0%, 0%, 0.5)"; //hue, saturatino, lightness, alpha/opacity
ctxHUD.font = "bold 20px Arial";




//For loading page
var btnPlay = new Button(410,520,150,220);
var mouseX = 0;
var mouseY = 0;
var isPlaying = false; //when the program starts, set the game to not playing






var myFox = new Fox();

var gameWidth = canvasBg.width;
var gameHeight = canvasBg.height;

var bunnies = [];
var spawnAmount = 5;

//for time 

var powerTime=0;
var tar=0;
var currentTime=0;


var store;
 function loadLog(){
 var tim = new Date();
 store = Math.floor((tim.getTime())/1000);
}


window.setInterval(loadLog, 1000);






//time ends


//reuest for animation from browse
//diff browsers have diff ways for doing this 
var requestAnimFrame = window.requestAnimationFrame || 
					   window.webkitRequestAnimationFrame || 
					   window.mozRequestAnimationFrame || 
					   window.msRequestAnimationFrame || 
					   window.oRequestAnimationFrame ||
					   function(callback){
					   	window.setTimeout(callback, 1000/60);
					   };



//load an image
var imgSprite = new Image(); //tell canvas that we are using an image
//tell browser where the image file is
imgSprite.src = 'images/sprite.png';
//when the sprite.png file loads, draw the background picture 
imgSprite.addEventListener('load',init,false);




//MAIN FUNCTIONS START
function init(){
	spawnBunnies(spawnAmount);
	drawMenu();
	document.addEventListener('click',mouseClicked, false);
}


function playGame(){
	drawBg(); //we only need to call this function during initialization
	startLoop(); //tells the game to start playing
	updateHUD();
	document.addEventListener('keydown',checkKeyDown, false);
	document.addEventListener('keyup',checkKeyUp,false);

}



function loop(){

	myFox.draw();
	myFox.checkHitEnemy();
	drawAllBunnies();
	requestAnimationFrame(loop);

	currentTime = Math.floor(d.getTime()/1000);	
}



function startLoop(){
	isPlaying = true;
	loop();
}

function stopLoop(){
	isPlaying = false;
}





//function that draws the background picture
function drawMenu(){
	var srcX = 0;
	var srcY = 600;
	var drawX = 0;
	var drawY = 0;
	//where the src is in the canvas, and where to draw the image in canvas
	ctxBg.drawImage(imgSprite,srcX,srcY,gameWidth,gameHeight,drawX,drawY,gameWidth,gameHeight);
}





//function that draws the background picture
function drawBg(){
	var srcX = 0;
	var srcY = 0;
	var drawX = 0;
	var drawY = 0;
	ctxBg.drawImage(imgSprite,srcX,srcY,gameWidth,gameHeight,drawX,drawY,gameWidth,gameHeight);
}





//Create bunnies 
function spawnBunnies(number){
	for(var i=0; i<number; i++){
		bunnies[bunnies.length] = new Bunny();
	}	
}

//Draw the bunnies created 
function drawAllBunnies(){
	clearCtxBunny();	//you must clear the canvas before redrawing to avoid lines of jets, erase the previous jet
	for(var i=0; i<bunnies.length; i++){

		bunnies[i].draw();
	}
}




//**************************MAIN FUNCTIONS END



//FOX FUNCTION STARTS
function Fox(){ //Fox constructor 
	this.srcX = 0;
	this.srcY = 601;	
	this.width = 50;
	this.height = 50;
	this.speed = 2;
	this.drawX = 220;
	this.drawY = 200;
	this.noseX = this.drawX+87;
	this.noseY = this.drawY+30;
	this.leftX = this.drawX;	
	this.rightX = this.drawX + this.width;
	this.topY = this.drawY;
	this.bottomY = this.drawY + this.height;
	this.isUpKey = false;
	this.isRightKey = false;
	this.isDownKey = false;
	this.isLeftKey = false;
	this.isSpacebar = false;
	this.isEating = false;

	this.hasHit = false;	


	this.score = 0;
	this.poweredUp = false;


	this.test = false;
}




Fox.prototype.draw = function(){
	clearCtxFox();	
	document.addEventListener('keydown',checkKeyDown, false);
	document.addEventListener('keyup',checkKeyUp,false);
	this.checkDirection();
	this.updateCoors();
   
	//calculate current time 
	

	if(store >= powerTime){
		//this.poweredUp = false;
	}




 	if((this.poweredUp) && (store >=powerTime)){
 		this.speed= 2;
 		//this.poweredUp = false;
 		ctxFox.drawImage(imgSprite,this.srcX,this.srcY,this.width,this.height,this.drawX,this.drawY,this.width,this.height);
 		console.log("condition1");	
 	} else if((!this.poweredUp) || (store > powerTime)){
 		this.speed = 2;
 		//this.poweredUp = false;
 		ctxFox.drawImage(imgSprite,this.srcX,this.srcY,this.width,this.height,this.drawX,this.drawY,this.width,this.height);
 		console.log("condition2");	
 	} else if((this.poweredUp) && (powerTime >= store)){
 		//draw Bad Fox
 		this.speed = 10;
 		ctxFox.drawImage(imgSprite,150,600,this.width,this.height,this.drawX,this.drawY,this.width,this.height);
 	
 		console.log("condition3");
 	} else{	
 		this.speed = 2;
 		//this.poweredUp = false;
		ctxFox.drawImage(imgSprite,this.srcX,this.srcY,this.width,this.height,this.drawX,this.drawY,this.width,this.height);
		console.log("condition4");
	}





	
}; //semi-colon is very recommended









Fox.prototype.checkDirection = function(){
	if(this.isUpKey && this.topY > 0){
		this.drawY  -= this.speed; 
	}

	if(this.isRightKey && this.rightX < gameWidth){
		this.drawX  += this.speed; 
	}

	if(this.isDownKey && this.bottomY < gameHeight){
		this.drawY  += this.speed; 
	}

	if(this.isLeftKey && this.leftX > 0){
		this.drawX  -= this.speed; 
	}
};


function clearCtxFox(){

	ctxFox.clearRect(0,0,gameWidth,gameHeight);	
}


Fox.prototype.updateCoors = function(){
	this.noseX = this.drawX+50;
	this.noseY = this.drawY+50;
	this.leftX = this.drawX;	
	this.rightX = this.drawX + this.width;
	this.topY = this.drawY;
	this.bottomY = this.drawY + this.height;
}




function updateHUD(){

	
	ctxHUD.clearRect(0, 0, gameWidth, gameHeight);
	ctxHUD.fillText("Score: "+ myFox.score,800,30); //text, drawX, drawY
	
}


Fox.prototype.updateScore = function(points){
	this.score +=points;
	updateHUD();
}
//****************************FOX FUNCTION ENDS






//BUNNY FUNCTION STARTS

function Bunny(){ //object
	this.srcX = 51;
	this.srcY = 601;	
	this.width = 48;
	this.height = 50;
	this.speed = 7;
	this.drawX = Math.floor(Math.random()*100)+gameWidth;
	this.drawY = Math.floor(Math.random()*550);
	this.rewardPoints = 5;	
}



//every time an enemyjet is drawn code starts
Bunny.prototype.draw = function(){
	
	this.drawX -= this.speed;
	
	ctxBunny.drawImage(imgSprite,this.srcX,this.srcY,this.width,this.height,this.drawX,this.drawY,this.width,this.height);
	this.checkEscaped();

}; //semi-colon is very recommended



//every time an enemyjet is drawn code starts
Bunny.prototype.checkEscaped = function(){
	if(this.drawX + this.width <= -2000){
		//delete the enemy

		this.recycleBunny();
	}
	
}; 


//once the tail of the enemy passes the screen, spawn the same enemy again from the rt side of screen
Bunny.prototype.recycleBunny = function(){
	//reset bunnies and reset their arrival time
    this.drawX = Math.floor(Math.random()*1000)+gameWidth;
	this.drawY = Math.floor(Math.random()*360);	
    this.srcX = 50;
	this.srcY = 600;

};


Bunny.prototype.clearCtxBunny = function(){
	ctxBunny.clearRect(0,0,gameWidth,gameHeight);
}


function clearCtxBunny(){
	ctxBunny.clearRect(0,0,gameWidth,gameHeight);
	
}




//**********************************************Bunny function ends






Fox.prototype.checkHitEnemy = function(){
	for(var i=0; i < bunnies.length; i++){
	if((this.drawX <= bunnies[i].drawX+ bunnies[i].width) &&
		 (this.drawX+this.width >= bunnies[i].drawX) &&
		 (this.drawY+this.height >= bunnies[i].drawY) &&
		 (this.drawY <= bunnies[i].drawY + bunnies[i].height) &&
		 (this.isSpacebar && bunnies[i].srcX !=100))
				{
				myFox.updateScore(1);

						//sound effect
				var bleep = new Audio();
				bleep.src = "eating.mp3";
				bleep.play();

				bunnies[i].srcX = 100;
				bunnies[i].srcY = 600;
				ctxBunny.drawImage(imgSprite,100,600,this.width,this.height,bunnies[i].drawX,bunnies[i].drawY,this.width,this.height);


		



				if((this.score>0) && (this.score%5==0)){
 					
					

					var d = new Date();
					powerTime=Math.floor(d.getTime()/1000);



					tar = powerTime;						
					powerTime = powerTime+20;	
					console.log("I am in console");						
					this.poweredUp = true;					
				}

	     }//if ends

	}//for ends	

				
}; //semi-colon is very recommended


//end of bullet functions




//EVENT FUNCTIONS START
function checkKeyDown(e){
	var keyID = e.keyCode || e.which;

	if(keyID === 38 || keyID === 87){ //up arrow or key
		myFox.isUpKey = true;
		e.preventDefault();
	}

	if(keyID === 39 || keyID === 68){ //right arrow or key
		myFox.isRightKey = true;
		e.preventDefault();
	}

	if(keyID === 40 || keyID === 83){ //down arrow or key
		myFox.isDownKey = true;
		e.preventDefault();
	}

	if(keyID === 37 || keyID === 65){ //left arrow or key
		myFox.isLeftKey = true;
		e.preventDefault();
	}

	if(keyID === 32){ //spacebar
		myFox.isSpacebar = true;
		e.preventDefault();
	}
}

function checkKeyUp(e){
	var keyID = e.keyCode || e.which;

	if(keyID === 38 || keyID === 87){ //up arrow or key
		myFox.isUpKey = false;
		e.preventDefault();
	}

	if(keyID === 39 || keyID === 68){ //right arrow or key
		myFox.isRightKey = false;
		e.preventDefault();
	}

	if(keyID === 40 || keyID === 83){ //down arrow or key
		myFox.isDownKey = false;
		e.preventDefault();
	}

	if(keyID === 37 || keyID === 65){ //left arrow or key
		myFox.isLeftKey = false;
		e.preventDefault();
	}

	if(keyID === 32){ //spacebar
		myFox.isSpacebar = false;
		e.preventDefault();	
	}
}
//**********************************EVENT FUNCTIONS END

   
    //button objects
function Button(xL, xR, yT, yB){
	this.xLeft = xL ;
	this.xRight = xR;
	this.yTop = yT;
	this.yBottom = yB;
}


Button.prototype.checkClicked = function(){
	if(this.xLeft <= mouseX && mouseX <= this.xRight && this.yTop <= mouseY && mouseY <=this.yBottom) return true;
}


function mouseClicked(e){
	mouseX = e.pageX - canvasBg.offsetLeft; //make sure you get values inside the canvas
	mouseY = e.pageY - canvasBg.offsetTop;
	if(!isPlaying){
		if(btnPlay.checkClicked()) playGame();
	}
}


